"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Select = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _reactOnclickout = _interopRequireDefault(require("react-onclickout"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Select =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Select, _React$Component);

  function Select(props) {
    var _this;

    _classCallCheck(this, Select);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Select).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "updateSelectBounds", function () {
      return _this.setState({
        selectBounds: _this.select.current.getBoundingClientRect()
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "dropDown", function () {
      var action = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'toggle';

      if (_this.props.forceOpen) {
        return _this.setState({
          dropdown: true
        });
      }

      if (action === 'close') {
        return _this.setState({
          dropdown: false,
          search: ''
        });
      }

      if (action === 'open') {
        return _this.setState({
          dropdown: true
        });
      }

      if (action === 'toggle') {
        return _this.setState({
          dropdown: !_this.state.dropdown
        });
      }

      return false;
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "addItem", function (item) {
      if (_this.props.multi) {
        if (_this.state.values.indexOf(item) !== -1) {
          return _this.removeItem(null, item, false);
        }

        _this.setState({
          values: [].concat(_toConsumableArray(_this.state.values), [item])
        });
      } else {
        _this.setState({
          values: [item],
          dropdown: false,
          search: ''
        });
      }

      return true;
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "removeItem", function (event, item) {
      var close = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

      if (event && close) {
        event.preventDefault();
        event.stopPropagation();

        _this.dropDown('close');
      }

      _this.setState({
        values: _this.state.values.filter(function (values) {
          return values.value !== item.value;
        })
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "setSearch", function (event) {
      return _this.setState({
        search: event.target.value
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "getInputSize", function () {
      if (_this.state.search) {
        return _this.state.search.length;
      }

      if (_this.state.values.length > 0) {
        return _this.props.addPlaceholder.length;
      }

      return _this.props.placeholder.length;
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "toggleSelectAll", function () {
      return _this.setState({
        values: _this.state.values.length === 0 ? _this.props.options : []
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "clearAll", function () {
      return _this.setState({
        values: []
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "isSelected", function (option) {
      return _this.state.values.indexOf(option) !== -1;
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "searchResults", function () {
      var regexp = new RegExp(_this.state.search, 'i');
      return _this.state.options.filter(function (item) {
        return regexp.test(item[_this.props.searchBy] || item.label);
      });
    });

    _this.state = {
      dropdown: false,
      values: _this.props.values,
      options: _this.props.options,
      search: '',
      selectBounds: {}
    };
    _this.methods = {
      removeItem: _this.removeItem,
      dropDown: _this.dropDown,
      addItem: _this.addItem,
      setSearch: _this.setSearch,
      getInputSize: _this.getInputSize,
      toggleSelectAll: _this.toggleSelectAll,
      clearAll: _this.clearAll,
      searchResults: _this.searchResults
    };
    _this.select = _react.default.createRef();
    return _this;
  }

  _createClass(Select, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      window.addEventListener('resize', this.updateSelectBounds);
      this.props.onChange(this.state.values);
      this.dropDown('close');

      if (this.select) {
        this.updateSelectBounds();
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      if (prevState.values !== this.state.values) {
        this.props.onChange(this.state.values);
        this.updateSelectBounds();
      }

      if (prevState.dropdown && prevState.dropdown !== this.state.dropdown) {
        this.props.onDropdownClose();
      }

      if (!prevState.dropdown && prevState.dropdown !== this.state.dropdown) {
        this.props.onDropdownOpen();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.updateSelectBounds);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var placeHolder = this.state.values.length > 0 && this.props.addPlaceholder || this.props.placeholder;
      return _react.default.createElement(_reactOnclickout.default, {
        onClickOut: function onClickOut() {
          return _this2.dropDown('close');
        }
      }, _react.default.createElement(ReactDropdownSelect, {
        ref: this.select,
        disabled: this.props.disabled,
        className: this.props.className
      }, _react.default.createElement(Content, {
        className: "react-dropdown-select-content ".concat(this.props.multi ? 'react-dropdown-select-type-multi' : 'react-dropdown-select-type-single'),
        onClick: function onClick() {
          return _this2.dropDown('open');
        }
      }, this.props.contentRenderer ? this.props.contentRenderer(this.props, this.state, this.methods) : _react.default.createElement(_react.default.Fragment, null, this.props.multi && this.state.values.map(function (item) {
        return _react.default.createElement(Option, {
          disabled: _this2.props.disabled,
          className: "react-dropdown-select-option"
        }, item.label, ' ', _react.default.createElement("span", {
          className: "react-dropdown-select-option-remove",
          onClick: function onClick(event) {
            return _this2.removeItem(event, item, true);
          }
        }, "\xD7"));
      }), !this.props.multi && this.state.values.length > 0 && _react.default.createElement("span", null, this.state.values[0].label), _react.default.createElement(Input, {
        tabIndex: "1",
        className: "react-dropdown-select-input",
        size: this.getInputSize(),
        value: this.state.search,
        onClick: function onClick() {
          return _this2.dropDown('open');
        },
        onChange: this.setSearch,
        placeholder: placeHolder
      }))), this.props.loading && _react.default.createElement(Loading, {
        className: "react-dropdown-select-loading"
      }), this.props.clearable && _react.default.createElement(Clear, {
        tabIndex: "2",
        onClick: function onClick() {
          return _this2.clearAll();
        },
        onKeyPress: function onKeyPress() {
          return _this2.clearAll();
        }
      }, "\xD7"), this.props.separator && _react.default.createElement(Separator, {
        className: "react-dropdown-select-separator"
      }), this.props.handle && _react.default.createElement(Handle, {
        tabIndex: "3",
        onClick: function onClick() {
          return _this2.dropDown();
        },
        onKeyPress: function onKeyPress() {
          return _this2.dropDown();
        },
        className: "react-dropdown-select-handle"
      }, this.state.dropdown ? _react.default.createElement(_react.default.Fragment, null, "\u203A") : _react.default.createElement(_react.default.Fragment, null, "\u2039")), this.state.dropdown && _react.default.createElement(DropDown, {
        tabIndex: "4",
        selectBounds: this.state.selectBounds,
        className: "react-dropdown-select-dropdown"
      }, this.props.dropdownRenderer ? this.props.dropdownRenderer(this.props, this.state, this.methods) : _react.default.createElement(_react.default.Fragment, null, this.searchResults().length === 0 ? _react.default.createElement(NoData, null, this.props.noDataRenderer) : this.searchResults().map(function (option, index) {
        return _react.default.createElement(Item, {
          tabIndex: index + 4,
          className: "react-dropdown-select-item ".concat(_this2.isSelected(option) ? 'react-dropdown-select-item-selected' : ''),
          onClick: function onClick() {
            return _this2.addItem(option);
          },
          onKeyPress: function onKeyPress() {
            return _this2.addItem(option);
          }
        }, option.label);
      })))));
    }
  }]);

  return Select;
}(_react.default.Component);

exports.Select = Select;

_defineProperty(Select, "propTypes", {
  onChange: _propTypes.default.func.isRequired,
  onDropdownClose: _propTypes.default.func.isRequired,
  onDropdownOpen: _propTypes.default.func.isRequired,
  values: _propTypes.default.array,
  options: _propTypes.default.array.isRequired,
  forceOpen: _propTypes.default.bool,
  multi: _propTypes.default.bool,
  placeholder: _propTypes.default.string,
  addPlaceholder: _propTypes.default.string,
  disabled: _propTypes.default.bool,
  className: _propTypes.default.string,
  contentRenderer: _propTypes.default.func,
  dropdownRenderer: _propTypes.default.func,
  loading: _propTypes.default.bool,
  clearable: _propTypes.default.bool,
  separator: _propTypes.default.bool,
  handle: _propTypes.default.bool,
  searchBy: _propTypes.default.string,
  noDataRenderer: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node])
});

Select.defaultProps = {
  addPlaceholder: '+ add',
  placeholder: 'Select...',
  values: [],
  multi: false,
  disabled: false,
  searchBy: 'label',
  clearable: true,
  forceOpen: undefined,
  noDataRenderer: 'No matches'
};

var ReactDropdownSelect =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "ReactDropdownSelect"
})(["display:flex;border:1px solid #ccc;width:100%;border-radius:2px;padding:2px 5px;flex-direction:row;align-items:center;min-height:36px;", ":focus-within{border-color:deepskyblue;}background:linear-gradient(#eee,#fff,#eee);"], function (_ref) {
  var disabled = _ref.disabled;
  return disabled ? 'cursor: not-allowed;pointer-events: none;opacity: 0.3;' : 'pointer-events: all;';
});

var Option =
/*#__PURE__*/
_styledComponents.default.span.withConfig({
  displayName: "Option"
})(["padding:0 5px;border-radius:2px;line-height:21px;margin:3px 0 3px 5px;background:deepskyblue;color:#fff;white-space:nowrap;display:inline-block;.react-dropdown-select-option-remove{cursor:pointer;width:22px;height:22px;display:inline-block;text-align:center;margin:0 -5px 0 0px;border-radius:0 3px 3px 0;}:hover,:hover > span{background:#00c4ee;}"]);

var Content =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "Content"
})(["flex:1;"]);

var Input =
/*#__PURE__*/
_styledComponents.default.input.withConfig({
  displayName: "Input"
})(["width:auto;border:none;margin-left:5px;background:transparent;:focus{outline:transparent;}font-size:smaller;"]);

var Separator =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "Separator"
})(["border-left:1px solid #ccc;width:1px;height:25px;display:block;"]);

var Loading =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "Loading"
})(["@keyframes dual-ring-spin{0%{transform:rotate(0deg);}100%{transform:rotate(180deg);}}padding:0 5px;display:block;width:auto;height:auto;:after{content:' ';display:block;width:16px;height:16px;border-radius:50%;border:1px solid red;border-color:deepskyblue transparent;animation:dual-ring-spin 0.7s ease-in-out infinite;margin:0 0 0 -10px;}"]);

var Handle =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "Handle"
})(["width:20px;text-align:center;line-height:25px;transform:rotate(-90deg);cursor:pointer;font-size:26px;"]);

var DropDown =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "DropDown"
})(["position:absolute;top:", "px;left:", "px;border:1px solid #ccc;width:", "px;padding:0;display:flex;flex-direction:column;background:#fff;border-radius:2px;box-shadow:0 0 10px 0 #0000003b;max-height:300px;overflow:auto;}"], function (_ref2) {
  var selectBounds = _ref2.selectBounds;
  return selectBounds.bottom + 5;
}, function (_ref3) {
  var selectBounds = _ref3.selectBounds;
  return selectBounds.left;
}, function (_ref4) {
  var selectBounds = _ref4.selectBounds;
  return selectBounds.width;
});

var Item =
/*#__PURE__*/
_styledComponents.default.span.withConfig({
  displayName: "Item"
})(["padding:10px;cursor:pointer;outline:none;:hover,:focus{background:#f2f2f2;}&.react-dropdown-select-item-selected{background:deepskyblue;color:#fff;border-bottom:1px solid #fff;}input{&[type='checkbox']{vertical-align:baseline;margin:0 10px 0 0;}}"]);

var Button =
/*#__PURE__*/
_styledComponents.default.button.withConfig({
  displayName: "Button"
})(["margin:10px;"]);

var Clear =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "Clear"
})(["line-height:25px;margin:0 10px;cursor:pointer;"]);

var NoData =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  displayName: "NoData"
})(["padding:10px;text-align:center;color:deepskyblue;"]);

var _default = Select;
exports.default = _default;